// dibdoc.h : interface of the CDibDoc class
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "dibapi.h"

class CDibDoc : public CDocument
{
protected: // create from serialization only
	CDibDoc();
	DECLARE_DYNCREATE(CDibDoc)

// Attributes
public:
	HDIB GetHDIB() const
		{ return m_hDIB; }
	CPalette* GetDocPalette() const
		{ return m_palDIB; }
	CSize GetDocSize() const
		{ return m_sizeDoc; }

// Operations
public:
	void ReplaceHDIB(HDIB hDIB);
	void InitDIBData();
	int m_MCUwidth;
	int m_MCUheight;
	int m_crop_xoffset;
	int m_crop_yoffset;
	int m_crop_width;
	int m_crop_height;
	int m_drop_logo;
	int m_drop_legend;

// Implementation
protected:
	virtual ~CDibDoc();

	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);

protected:
	HDIB m_hDIB;
	CPalette* m_palDIB;
	CSize m_sizeDoc;

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
protected:
	virtual BOOL    OnNewDocument();

// Generated message map functions
protected:
	//{{AFX_MSG(CDibDoc)
	afx_msg void OnFileSaveCopyAs();
	afx_msg void OnOptionsDropLogo();
	afx_msg void OnOptionsNoScale();
	afx_msg void OnOptionsDrop10m();
	afx_msg void OnOptionsDrop20m();
	afx_msg void OnOptionsDrop50m();
	afx_msg void OnUpdateOptionsDropLogo(CCmdUI *pCmdUI);
	afx_msg void OnUpdateOptionsNoScale(CCmdUI *pCmdUI);
	afx_msg void OnUpdateOptionsDrop10m(CCmdUI *pCmdUI);
	afx_msg void OnUpdateOptionsDrop20m(CCmdUI *pCmdUI);
	afx_msg void OnUpdateOptionsDrop50m(CCmdUI *pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
