// diblook.cpp : Defines the class behaviors for the application.
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1997 Microsoft Corporation
// All rights reserved.
//
// This source code is only intended as a supplement to the
// Microsoft Foundation Classes Reference and related
// electronic documentation provided with the library.
// See these sources for detailed information regarding the
// Microsoft Foundation Classes product.

#include "stdafx.h"
#include "diblook.h"

#include "mainfrm.h"
#include "dibdoc.h"
#include "dibview.h"

#include "jpegdib.h"
#include "docrop.h"

#include <afxcmn.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDibLookApp

BEGIN_MESSAGE_MAP(CDibLookApp, CWinApp)
	//{{AFX_MSG_MAP(CDibLookApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_PREFERENCES, OnFilePreferences)
	ON_COMMAND(ID_PROJECT_ADDFRAME, OnProjectAddFrame)
	ON_COMMAND(ID_PROJECT_SHOWLIST, OnProjectShowList)
	ON_COMMAND(ID_PROJECT_SAVEPROJECTAS, OnProjectSaveProjectAs)
	ON_COMMAND(ID_VIEW_BLOCKGRID, OnViewBlockGrid)
	ON_COMMAND(ID_OPTIONS_ENDPOINTSNAP, OnOptionsEndpointSnap)
	ON_UPDATE_COMMAND_UI(ID_VIEW_BLOCKGRID, OnUpdateViewBlockGrid)
	ON_UPDATE_COMMAND_UI(ID_OPTIONS_ENDPOINTSNAP, OnUpdateOptionsEndpointSnap)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDibLookApp construction
// Place all significant initialization in InitInstance

CDibLookApp::CDibLookApp()
{
	m_show_blockgrid = 0;
	m_endpoint_snap = 1;
	m_optimize_coding = 2;
	m_copyoption = 2;
	m_width = 208;
	m_height = 208;
	m_xoffset = -1;
	m_yoffset = -1;
	m_drop_logo_pre = 0;
	m_drop_legend_pre = 0;
	m_define_frame = 0;
	m_path[0][0] = 0;
	m_path[1][0] = 0;
	m_path[2][0] = 0;
	m_path[3][0] = 0;
	m_cols = 5;
	m_rows = 2;
	m_x_spacing = 16;
	m_y_spacing = 16;
	m_com[0] = 0;
	m_count = 0;
	m_appended = 0;
	m_filecomment[0] = 0;
	m_logo_text[0] = 0;
	m_logo_menu[0] = 0;
	m_logo_info[0] = 0;
	m_legend_text[0][0] = 0;
	m_legend_text[1][0] = 0;
	m_legend_text[2][0] = 0;
	m_legend_text[3][0] = 0;
	m_legend_menu[0][0] = 0;
	m_legend_menu[1][0] = 0;
	m_legend_menu[2][0] = 0;
	m_legend_menu[3][0] = 0;
	m_legend_info[0][0] = 0;
	m_legend_info[1][0] = 0;
	m_legend_info[2][0] = 0;
	m_legend_info[3][0] = 0;
	strcpy(m_filebase[0], "drop\\logo");
	strcpy(m_filebase[1], "drop\\legend1");
	strcpy(m_filebase[2], "drop\\legend2");
	strcpy(m_filebase[3], "drop\\legend3");
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CDibLookApp object

CDibLookApp theApp;

void load_inf(void)
{
	FILE *fp;
	char buffer[256], *p;

	if ((fp = fopen(theApp.m_path[4], "r")) == NULL)
		return;
	fscanf(fp, "OptimizeCoding = %d\n", &theApp.m_optimize_coding);
	if (theApp.m_optimize_coding < 0 || theApp.m_optimize_coding > 2)
		theApp.m_optimize_coding = 0;
	fscanf(fp, "CopyOption = %d\n", &theApp.m_copyoption);
	if (theApp.m_copyoption < 0 || theApp.m_copyoption > 2)
		theApp.m_copyoption = 2;
	fscanf(fp, "DropLogo = %d\n", &theApp.m_drop_logo_pre);
	if (theApp.m_drop_logo_pre < 0 || theApp.m_drop_logo_pre > 1)
		theApp.m_drop_logo_pre = 0;
	fscanf(fp, "DropLegend = %d\n", &theApp.m_drop_legend_pre);
	if (theApp.m_drop_legend_pre < 0 || theApp.m_drop_legend_pre > 3)
		theApp.m_drop_legend_pre = 0;
	fscanf(fp, "DefineFrame = %d\n", &theApp.m_define_frame);
	if (theApp.m_define_frame < 0 || theApp.m_define_frame > 1)
		theApp.m_define_frame = 0;
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "FileComment = ", 14) == 0)
	{
		strcpy(theApp.m_filecomment, buffer + 14);
		p = strchr(theApp.m_filecomment, '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "LogoText = ", 11) == 0)
	{
		strcpy(theApp.m_logo_text, buffer + 11);
		p = strchr(theApp.m_logo_text, '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "LogoMenu = ", 11) == 0)
	{
		strcpy(theApp.m_logo_menu, buffer + 11);
		p = strchr(theApp.m_logo_menu, '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "LogoInfo = ", 11) == 0)
	{
		strcpy(theApp.m_logo_info, buffer + 11);
		p = strchr(theApp.m_logo_info, '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "LogoFileBase = ", 15) == 0)
	{
		strcpy(theApp.m_filebase[0], buffer + 15);
		p = strchr(theApp.m_filebase[0], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend0Text = ", 14) == 0)
	{
		strcpy(theApp.m_legend_text[0], buffer + 14);
		p = strchr(theApp.m_legend_text[0], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend0Menu = ", 14) == 0)
	{
		strcpy(theApp.m_legend_menu[0], buffer + 14);
		p = strchr(theApp.m_legend_menu[0], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend0Info = ", 14) == 0)
	{
		strcpy(theApp.m_legend_info[0], buffer + 14);
		p = strchr(theApp.m_legend_info[0], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend1Text = ", 14) == 0)
	{
		strcpy(theApp.m_legend_text[1], buffer + 14);
		p = strchr(theApp.m_legend_text[1], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend1Menu = ", 14) == 0)
	{
		strcpy(theApp.m_legend_menu[1], buffer + 14);
		p = strchr(theApp.m_legend_menu[1], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend1Info = ", 14) == 0)
	{
		strcpy(theApp.m_legend_info[1], buffer + 14);
		p = strchr(theApp.m_legend_info[1], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend1FileBase = ", 18) == 0)
	{
		strcpy(theApp.m_filebase[1], buffer + 18);
		p = strchr(theApp.m_filebase[1], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend2Text = ", 14) == 0)
	{
		strcpy(theApp.m_legend_text[2], buffer + 14);
		p = strchr(theApp.m_legend_text[2], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend2Menu = ", 14) == 0)
	{
		strcpy(theApp.m_legend_menu[2], buffer + 14);
		p = strchr(theApp.m_legend_menu[2], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend2Info = ", 14) == 0)
	{
		strcpy(theApp.m_legend_info[2], buffer + 14);
		p = strchr(theApp.m_legend_info[2], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend2FileBase = ", 18) == 0)
	{
		strcpy(theApp.m_filebase[2], buffer + 18);
		p = strchr(theApp.m_filebase[2], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend3Text = ", 14) == 0)
	{
		strcpy(theApp.m_legend_text[3], buffer + 14);
		p = strchr(theApp.m_legend_text[3], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend3Menu = ", 14) == 0)
	{
		strcpy(theApp.m_legend_menu[3], buffer + 14);
		p = strchr(theApp.m_legend_menu[3], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend3Info = ", 14) == 0)
	{
		strcpy(theApp.m_legend_info[3], buffer + 14);
		p = strchr(theApp.m_legend_info[3], '\n');
		if (p) *p = 0;
	}
	fgets(buffer, sizeof(buffer), fp);
	if (strncmp(buffer, "Legend3FileBase = ", 18) == 0)
	{
		strcpy(theApp.m_filebase[3], buffer + 18);
		p = strchr(theApp.m_filebase[3], '\n');
		if (p) *p = 0;
	}
	fclose(fp);
}

void save_inf(void)
{
	FILE *fp;

	if ((fp = fopen(theApp.m_path[4], "w")) == NULL)
		return;
	fprintf(fp, "OptimizeCoding = %d\n", theApp.m_optimize_coding);
	fprintf(fp, "CopyOption = %d\n", theApp.m_copyoption);
	fprintf(fp, "DropLogo = %d\n", theApp.m_drop_logo_pre);
	fprintf(fp, "DropLegend = %d\n", theApp.m_drop_legend_pre);
	fprintf(fp, "DefineFrame = %d\n", theApp.m_define_frame);
	fprintf(fp, "FileComment = %s\n", theApp.m_filecomment);
	fprintf(fp, "LogoText = %s\n", theApp.m_logo_text);
	fprintf(fp, "LogoMenu = %s\n", theApp.m_logo_menu);
	fprintf(fp, "LogoInfo = %s\n", theApp.m_logo_info);
	fprintf(fp, "LogoFileBase = %s\n", theApp.m_filebase[0]);
	fprintf(fp, "Legend0Text = %s\n", theApp.m_legend_text[0]);
	fprintf(fp, "Legend0Menu = %s\n", theApp.m_legend_menu[0]);
	fprintf(fp, "Legend0Info = %s\n", theApp.m_legend_info[0]);
	fprintf(fp, "Legend1Text = %s\n", theApp.m_legend_text[1]);
	fprintf(fp, "Legend1Menu = %s\n", theApp.m_legend_menu[1]);
	fprintf(fp, "Legend1Info = %s\n", theApp.m_legend_info[1]);
	fprintf(fp, "Legend1FileBase = %s\n", theApp.m_filebase[1]);
	fprintf(fp, "Legend2Text = %s\n", theApp.m_legend_text[2]);
	fprintf(fp, "Legend2Menu = %s\n", theApp.m_legend_menu[2]);
	fprintf(fp, "Legend2Info = %s\n", theApp.m_legend_info[2]);
	fprintf(fp, "Legend2FileBase = %s\n", theApp.m_filebase[2]);
	fprintf(fp, "Legend3Text = %s\n", theApp.m_legend_text[3]);
	fprintf(fp, "Legend3Menu = %s\n", theApp.m_legend_menu[3]);
	fprintf(fp, "Legend3Info = %s\n", theApp.m_legend_info[3]);
	fprintf(fp, "Legend3FileBase = %s\n", theApp.m_filebase[3]);
	fclose(fp);
}

/////////////////////////////////////////////////////////////////////////////
// CDibLookApp initialization

BOOL CDibLookApp::InitInstance()
{
	// Standard initialization
	//  (if you are not using these features and wish to reduce the size
	// of your final executable, you should remove the following initialization

	Enable3dControls();     // Use 3d controls in dialogs
	LoadStdProfileSettings(8);  // Load standard INI file options (including MRU)

	// Register document templates which serve as connection between
	//  documents and views.  Views are contained in the specified view

	AddDocTemplate(new CMultiDocTemplate(IDR_JPGTYPE,
			RUNTIME_CLASS(CDibDoc),
			RUNTIME_CLASS(CMDIChildWnd),        // standard MDI child frame
			RUNTIME_CLASS(CDibView)));

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	m_pMainWnd = pMainFrame;

	GetCurrentDirectory(sizeof(m_path[0]), m_path[0]);
	if (strlen(m_path[0]) && m_path[0][strlen(m_path[0]) - 1] != '\\')
		strcat(m_path[0], "\\");
	strcpy(m_path[1], m_path[0]);
	strcpy(m_path[2], m_path[0]);
	strcpy(m_path[3], m_path[0]);
	strcpy(m_path[4], m_path[0]);
	strcat(m_path[4], "jpegjoin.inf");
	load_inf();
	strcat(m_path[0], m_filebase[0]);
	strcat(m_path[0], "_xxx.jpg");
	m_sampptr[0] = m_path[0] + strlen(m_path[0]) - 7;
	strcat(m_path[1], m_filebase[1]);
	strcat(m_path[1], "_xxx.jpg");
	m_sampptr[1] = m_path[1] + strlen(m_path[1]) - 7;
	strcat(m_path[2], m_filebase[2]);
	strcat(m_path[2], "_xxx.jpg");
	m_sampptr[2] = m_path[2] + strlen(m_path[2]) - 7;
	strcat(m_path[3], m_filebase[3]);
	strcat(m_path[3], "_xxx.jpg");
	m_sampptr[3] = m_path[3] + strlen(m_path[3]) - 7;

	// enable file manager drag/drop and DDE Execute open
	m_pMainWnd->DragAcceptFiles();

	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	if (cmdInfo.m_nShellCommand != CCommandLineInfo::FileOpen) {
		cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;
	}

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	return TRUE;
}

#ifdef _MAC

BOOL CDibLookApp::CreateInitialDocument()
{
	// do *not* create a new (empty) document, but do return TRUE since no
	// failure occurred

	return TRUE;
}

#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg() : CDialog(CAboutDlg::IDD)
		{
			//{{AFX_DATA_INIT(CAboutDlg)
			//}}AFX_DATA_INIT
		}

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
		enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDibLookApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

void CDibLookApp::OnViewBlockGrid()
{
  m_show_blockgrid ^= 1;

  POSITION pos = GetFirstDocTemplatePosition();
  CDocTemplate *pDoct = GetNextDocTemplate( pos );
  if (pDoct == NULL) return;

  pos = pDoct->GetFirstDocPosition();
  while (pos != NULL)
  {
	  CDocument *pDoc = pDoct->GetNextDoc( pos );
	  pDoc->UpdateAllViews(NULL);
  }
}

void CDibLookApp::OnUpdateViewBlockGrid(CCmdUI *pCmdUI)
{
  pCmdUI->SetCheck(m_show_blockgrid);
}

void CDibLookApp::OnOptionsEndpointSnap()
{
  m_endpoint_snap ^= 1;
}

void CDibLookApp::OnUpdateOptionsEndpointSnap(CCmdUI *pCmdUI)
{
  pCmdUI->SetCheck(m_endpoint_snap);
}

/////////////////////////////////////////////////////////////////////////////
// CDibLookApp commands

class CPrefDlg : public CDialog
{
public:
	CPrefDlg() : CDialog(CPrefDlg::IDD)
		{
			//{{AFX_DATA_INIT(CPrefDlg)
			//}}AFX_DATA_INIT
		}
// Dialog Data
	//{{AFX_DATA(CPrefDlg)
		enum { IDD = IDD_PREFBOX };
		int m_drop_logo_pre;
		int m_define_frame;
	//}}AFX_DATA
	int m_optimize_coding;
	int m_copyoption;
	int m_drop_legend_pre;
// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnButton1();
	virtual void OnButton2();
	//{{AFX_MSG(CPrefDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

void CPrefDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPrefDlg)
	DDX_Check(pDX, IDC_CHECK1, m_drop_legend_pre);
	DDX_Check(pDX, IDC_CHECK2, m_define_frame);
	//}}AFX_DATA_MAP
}

BOOL CPrefDlg::OnInitDialog()
{
  CDibLookApp *myapp = (CDibLookApp *) AfxGetApp();

  if (m_optimize_coding == 0)
	((CButton *)GetDlgItem(IDC_RADIO4))->SetCheck(TRUE);
  else if (m_optimize_coding == 1)
	((CButton *)GetDlgItem(IDC_RADIO5))->SetCheck(TRUE);
  else
	((CButton *)GetDlgItem(IDC_RADIO6))->SetCheck(TRUE);
  if (m_copyoption == 0)
	((CButton *)GetDlgItem(IDC_RADIO1))->SetCheck(TRUE);
  else if (m_copyoption == 1)
	((CButton *)GetDlgItem(IDC_RADIO2))->SetCheck(TRUE);
  else
	((CButton *)GetDlgItem(IDC_RADIO3))->SetCheck(TRUE);
  if (m_drop_legend_pre == 0)
	((CButton *)GetDlgItem(IDC_RADIO7))->SetCheck(TRUE);
  else if (m_drop_legend_pre == 1)
	((CButton *)GetDlgItem(IDC_RADIO8))->SetCheck(TRUE);
  else if (m_drop_legend_pre == 2)
	((CButton *)GetDlgItem(IDC_RADIO9))->SetCheck(TRUE);
  else
	((CButton *)GetDlgItem(IDC_RADIO10))->SetCheck(TRUE);

  if (myapp->m_logo_text[0])
	SetDlgItemText(IDC_CHECK1, myapp->m_logo_text);
  if (myapp->m_legend_text[0][0])
	SetDlgItemText(IDC_RADIO7, myapp->m_legend_text[0]);
  if (myapp->m_legend_text[1][0])
	SetDlgItemText(IDC_RADIO8, myapp->m_legend_text[1]);
  if (myapp->m_legend_text[2][0])
	SetDlgItemText(IDC_RADIO9, myapp->m_legend_text[2]);
  if (myapp->m_legend_text[3][0])
	SetDlgItemText(IDC_RADIO10, myapp->m_legend_text[3]);

  CDialog::OnInitDialog();
  return TRUE;
}

void CPrefDlg::OnOK()
{
  CDialog::OnOK();
  if (((CButton *)GetDlgItem(IDC_RADIO4))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_optimize_coding = 0;
  else if (((CButton *)GetDlgItem(IDC_RADIO5))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_optimize_coding = 1;
  else
	((CDibLookApp *)AfxGetApp())->m_optimize_coding = 2;
  if (((CButton *)GetDlgItem(IDC_RADIO1))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_copyoption = 0;
  else if (((CButton *)GetDlgItem(IDC_RADIO2))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_copyoption = 1;
  else
	((CDibLookApp *)AfxGetApp())->m_copyoption = 2;
  if (((CButton *)GetDlgItem(IDC_RADIO7))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_drop_legend_pre = 0;
  else if (((CButton *)GetDlgItem(IDC_RADIO8))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_drop_legend_pre = 1;
  else if (((CButton *)GetDlgItem(IDC_RADIO9))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_drop_legend_pre = 2;
  else
	((CDibLookApp *)AfxGetApp())->m_drop_legend_pre = 3;
}

void CPrefDlg::OnButton1()
{
  if (((CButton *)GetDlgItem(IDC_RADIO4))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_optimize_coding = 0;
  else if (((CButton *)GetDlgItem(IDC_RADIO5))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_optimize_coding = 1;
  else
	((CDibLookApp *)AfxGetApp())->m_optimize_coding = 2;
  if (((CButton *)GetDlgItem(IDC_RADIO1))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_copyoption = 0;
  else if (((CButton *)GetDlgItem(IDC_RADIO2))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_copyoption = 1;
  else
	((CDibLookApp *)AfxGetApp())->m_copyoption = 2;
  if (((CButton *)GetDlgItem(IDC_RADIO7))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_drop_legend_pre = 0;
  else if (((CButton *)GetDlgItem(IDC_RADIO8))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_drop_legend_pre = 1;
  else if (((CButton *)GetDlgItem(IDC_RADIO9))->GetCheck())
	((CDibLookApp *)AfxGetApp())->m_drop_legend_pre = 2;
  else
	((CDibLookApp *)AfxGetApp())->m_drop_legend_pre = 3;

  if (((CButton *)GetDlgItem(IDC_CHECK1))->GetCheck())
	m_drop_logo_pre = 1;
  else
	m_drop_logo_pre = 0;
  if (((CButton *)GetDlgItem(IDC_CHECK2))->GetCheck())
	m_define_frame = 1;
  else
	m_define_frame = 0;
  ((CDibLookApp *)AfxGetApp())->m_drop_logo_pre = m_drop_logo_pre;
  ((CDibLookApp *)AfxGetApp())->m_define_frame = m_define_frame;

  save_inf();
}

void CPrefDlg::OnButton2()
{
  load_inf();

  m_drop_logo_pre = ((CDibLookApp *)AfxGetApp())->m_drop_logo_pre;
  m_define_frame = ((CDibLookApp *)AfxGetApp())->m_define_frame;
  m_optimize_coding = ((CDibLookApp *)AfxGetApp())->m_optimize_coding;
  m_copyoption = ((CDibLookApp *)AfxGetApp())->m_copyoption;
  m_drop_legend_pre = ((CDibLookApp *)AfxGetApp())->m_drop_legend_pre;

  if (m_drop_logo_pre)
	((CButton *)GetDlgItem(IDC_CHECK1))->SetCheck(TRUE);
  else
	((CButton *)GetDlgItem(IDC_CHECK1))->SetCheck(FALSE);
  if (m_define_frame)
	((CButton *)GetDlgItem(IDC_CHECK2))->SetCheck(TRUE);
  else
	((CButton *)GetDlgItem(IDC_CHECK2))->SetCheck(FALSE);

  ((CButton *)GetDlgItem(IDC_RADIO1))->SetCheck(FALSE);
  ((CButton *)GetDlgItem(IDC_RADIO2))->SetCheck(FALSE);
  ((CButton *)GetDlgItem(IDC_RADIO3))->SetCheck(FALSE);
  ((CButton *)GetDlgItem(IDC_RADIO4))->SetCheck(FALSE);
  ((CButton *)GetDlgItem(IDC_RADIO5))->SetCheck(FALSE);
  ((CButton *)GetDlgItem(IDC_RADIO6))->SetCheck(FALSE);
  ((CButton *)GetDlgItem(IDC_RADIO7))->SetCheck(FALSE);
  ((CButton *)GetDlgItem(IDC_RADIO8))->SetCheck(FALSE);
  ((CButton *)GetDlgItem(IDC_RADIO9))->SetCheck(FALSE);
  ((CButton *)GetDlgItem(IDC_RADIO10))->SetCheck(FALSE);

  if (m_optimize_coding == 0)
	((CButton *)GetDlgItem(IDC_RADIO4))->SetCheck(TRUE);
  else if (m_optimize_coding == 1)
	((CButton *)GetDlgItem(IDC_RADIO5))->SetCheck(TRUE);
  else
	((CButton *)GetDlgItem(IDC_RADIO6))->SetCheck(TRUE);
  if (m_copyoption == 0)
	((CButton *)GetDlgItem(IDC_RADIO1))->SetCheck(TRUE);
  else if (m_copyoption == 1)
	((CButton *)GetDlgItem(IDC_RADIO2))->SetCheck(TRUE);
  else
	((CButton *)GetDlgItem(IDC_RADIO3))->SetCheck(TRUE);
  if (m_drop_legend_pre == 0)
	((CButton *)GetDlgItem(IDC_RADIO7))->SetCheck(TRUE);
  else if (m_drop_legend_pre == 1)
	((CButton *)GetDlgItem(IDC_RADIO8))->SetCheck(TRUE);
  else if (m_drop_legend_pre == 2)
	((CButton *)GetDlgItem(IDC_RADIO9))->SetCheck(TRUE);
  else
	((CButton *)GetDlgItem(IDC_RADIO10))->SetCheck(TRUE);
}

BEGIN_MESSAGE_MAP(CPrefDlg, CDialog)
	//{{AFX_MSG_MAP(CPrefDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CDibLookApp::OnFilePreferences()
{
	CPrefDlg prefDlg;
	prefDlg.m_optimize_coding = m_optimize_coding;
	prefDlg.m_copyoption = m_copyoption;
	prefDlg.m_drop_legend_pre = m_drop_legend_pre;
	prefDlg.m_drop_logo_pre = m_drop_logo_pre;
	prefDlg.m_define_frame = m_define_frame;
	if (prefDlg.DoModal() != IDOK) return;
	m_drop_logo_pre = prefDlg.m_drop_logo_pre;
	m_define_frame = prefDlg.m_define_frame;
}

class CAddDlg : public CDialog
{
public:
	CAddDlg() : CDialog(CAddDlg::IDD)
		{
			//{{AFX_DATA_INIT(CAddDlg)
			//}}AFX_DATA_INIT
		}
// Dialog Data
	//{{AFX_DATA(CAddDlg)
		enum { IDD = IDD_ADDFRAME };
		int m_drop_logo;
		int m_drop_legend;
	//}}AFX_DATA
// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	//{{AFX_MSG(CAddDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

void CAddDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAddDlg)
	DDX_Check(pDX, IDC_CHECK1, m_drop_logo);
	DDX_Radio(pDX, IDC_RADIO1, m_drop_legend);
	//}}AFX_DATA_MAP
}


BOOL CAddDlg::OnInitDialog()
{
  CDibLookApp *myapp = (CDibLookApp *) AfxGetApp();

  if (myapp->m_logo_text[0])
	SetDlgItemText(IDC_CHECK1, myapp->m_logo_text);
  if (myapp->m_legend_text[0][0])
	SetDlgItemText(IDC_RADIO1, myapp->m_legend_text[0]);
  if (myapp->m_legend_text[1][0])
	SetDlgItemText(IDC_RADIO2, myapp->m_legend_text[1]);
  if (myapp->m_legend_text[2][0])
	SetDlgItemText(IDC_RADIO3, myapp->m_legend_text[2]);
  if (myapp->m_legend_text[3][0])
	SetDlgItemText(IDC_RADIO4, myapp->m_legend_text[3]);

  CDialog::OnInitDialog();
  return TRUE;
}

BEGIN_MESSAGE_MAP(CAddDlg, CDialog)
	//{{AFX_MSG_MAP(CAddDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CDibLookApp::OnProjectAddFrame()
{
  if (m_count >= 20) return;

  CMDIFrameWnd *pFrame = (CMDIFrameWnd *) m_pMainWnd;
  if (pFrame == NULL) return;

  // Get the active MDI child window.
  CMDIChildWnd *pChild = 
             (CMDIChildWnd *) pFrame->GetActiveFrame();
  if (pChild == NULL) return;

  // or CMDIChildWnd *pChild = pFrame->MDIGetActive();

  CDibDoc *pDoc = (CDibDoc *) pChild->GetActiveDocument();
  if (pDoc == NULL) return;

  CAddDlg addDlg;
  addDlg.m_drop_logo = pDoc->m_drop_logo;
  addDlg.m_drop_legend = pDoc->m_drop_legend;
  if (addDlg.DoModal() != IDOK) return;
  pDoc->m_drop_logo = addDlg.m_drop_logo;
  pDoc->m_drop_legend = addDlg.m_drop_legend;

  strcpy(m_list[m_count], pDoc->GetPathName());
  strcpy(m_title[m_count], pDoc->GetTitle());
  m_crop_xoffset[m_count] = pDoc->m_crop_xoffset;
  m_crop_yoffset[m_count] = pDoc->m_crop_yoffset;
  m_crop_width[m_count] = pDoc->m_crop_width;
  m_crop_height[m_count] = pDoc->m_crop_height;
  m_MCUwidth[m_count] = pDoc->m_MCUwidth;
  m_MCUheight[m_count] = pDoc->m_MCUheight;
  m_drop_logo[m_count] = pDoc->m_drop_logo;
  m_drop_legend[m_count] = pDoc->m_drop_legend;

  CMenu* pMenu = AfxGetMainWnd()->GetMenu()->GetSubMenu(1);

  if (m_appended == 0) pMenu->AppendMenu(MF_SEPARATOR);

  char buffer[128];

  if (m_count != m_appended)
  {
	for (int i = 0; i < m_appended; i++)
	{
	  pMenu->DeleteMenu(100 + i, MF_BYCOMMAND);
	}
	for (i = 0; i < m_count; i++)
	{
	  sprintf(buffer, "%s%d %s %dx%d+%d+%d %dx%d %d %d",
			  i < 9 ? "&" : "",
			  i + 1,
			  m_title[i],
			  m_crop_width[i],
			  m_crop_height[i],
			  m_crop_xoffset[i],
			  m_crop_yoffset[i],
			  m_MCUwidth[i],
			  m_MCUheight[i],
			  m_drop_logo[i],
			  m_drop_legend[i]);
	  pMenu->AppendMenu(MF_STRING, 100 + i, buffer);
	}
  }

  sprintf(buffer, "%s%d %s %dx%d+%d+%d %dx%d %d %d",
		  m_count < 9 ? "&" : "",
		  m_count + 1,
		  pDoc->GetTitle(),
		  pDoc->m_crop_width,
		  pDoc->m_crop_height,
		  pDoc->m_crop_xoffset,
		  pDoc->m_crop_yoffset,
		  pDoc->m_MCUwidth,
		  pDoc->m_MCUheight,
		  pDoc->m_drop_logo,
		  pDoc->m_drop_legend);
  pMenu->AppendMenu(MF_STRING, 100 + m_count, buffer);

  m_count++; m_appended = m_count;
}

class CListDlg : public CDialog
{
public:
	CListDlg() : CDialog(CListDlg::IDD)
		{
			//{{AFX_DATA_INIT(CListDlg)
			//}}AFX_DATA_INIT
		}
// Dialog Data
	//{{AFX_DATA(CListDlg)
		enum { IDD = IDD_LISTBOX };
	//}}AFX_DATA
// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	virtual void OnButton1();
	//{{AFX_MSG(CListDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

void CListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListDlg)
	//}}AFX_DATA_MAP
}

BOOL CListDlg::OnInitDialog()
{
	char buffer[128];
	CDibLookApp *myapp = (CDibLookApp *) AfxGetApp();
	sprintf(buffer, "%d Frames in List", myapp->m_count);
	SetDlgItemText(IDC_STATICX, buffer);

	((CListCtrl *)GetDlgItem(IDC_LIST3))->InsertColumn(0, "Nr.", LVCFMT_LEFT, 32);

	LV_COLUMN col;
	col.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	col.fmt = LVCFMT_LEFT;
	col.cx = 96;
	col.pszText = "Filename";
	col.iSubItem = 1;
	((CListCtrl *)GetDlgItem(IDC_LIST3))->InsertColumn(2, &col);
	col.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	col.fmt = LVCFMT_LEFT;
	col.cx = 96;
	col.pszText = "Cropspec";
	col.iSubItem = 2;
	((CListCtrl *)GetDlgItem(IDC_LIST3))->InsertColumn(3, &col);
	col.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	col.fmt = LVCFMT_LEFT;
	col.cx = 48;
	col.pszText = "Block";
	col.iSubItem = 3;
	((CListCtrl *)GetDlgItem(IDC_LIST3))->InsertColumn(4, &col);
	col.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	col.fmt = LVCFMT_LEFT;
	col.cx = 32;
	col.pszText = "Lo.";
	col.iSubItem = 4;
	((CListCtrl *)GetDlgItem(IDC_LIST3))->InsertColumn(5, &col);
	col.mask = LVCF_FMT | LVCF_SUBITEM | LVCF_TEXT | LVCF_WIDTH;
	col.fmt = LVCFMT_LEFT;
	col.cx = 32;
	col.pszText = "Le.";
	col.iSubItem = 5;
	((CListCtrl *)GetDlgItem(IDC_LIST3))->InsertColumn(6, &col);

	((CListCtrl *)GetDlgItem(IDC_LIST3))->SetExtendedStyle(LVS_REPORT |
		LVS_EX_FULLROWSELECT | LVS_EX_TWOCLICKACTIVATE);

	for (int i = 0; i < myapp->m_count; i++)
	{
		sprintf(buffer, "%2d.", i + 1);
		((CListCtrl *)GetDlgItem(IDC_LIST3))->InsertItem(i, buffer);
		((CListCtrl *)GetDlgItem(IDC_LIST3))->SetItemText(i, 1,
			myapp->m_title[i]);
		sprintf(buffer, "%dx%d+%d+%d",
			myapp->m_crop_width[i],
			myapp->m_crop_height[i],
			myapp->m_crop_xoffset[i],
			myapp->m_crop_yoffset[i]);
		((CListCtrl *)GetDlgItem(IDC_LIST3))->SetItemText(i, 2, buffer);
		sprintf(buffer, "%dx%d",
			myapp->m_MCUwidth[i],
			myapp->m_MCUheight[i]);
		((CListCtrl *)GetDlgItem(IDC_LIST3))->SetItemText(i, 3, buffer);
		sprintf(buffer, "%d",
			myapp->m_drop_logo[i]);
		((CListCtrl *)GetDlgItem(IDC_LIST3))->SetItemText(i, 4, buffer);
		sprintf(buffer, "%d",
			myapp->m_drop_legend[i]);
		((CListCtrl *)GetDlgItem(IDC_LIST3))->SetItemText(i, 5, buffer);
	}

	CDialog::OnInitDialog();
	return TRUE;
}

void CListDlg::OnButton1()
{
	char buffer[128];
	CDibLookApp *myapp = (CDibLookApp *) AfxGetApp();
	int count = ((CListCtrl *)GetDlgItem(IDC_LIST3))->GetSelectedCount();
	int i = ((CListCtrl *)GetDlgItem(IDC_LIST3))->GetNextItem(-1, count ? LVNI_SELECTED : LVNI_FOCUSED);
	if (i == -1)
	{
		MessageBox("No Frame selected.",
			"Delete Frames",
			MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	if (count > 1)
	{
		sprintf(buffer, "Delete %d Frames?", count);
	}
	else
	{
		sprintf(buffer, "Delete Frame Nr. %d?", i + 1);
	}
	if (MessageBox(buffer,
		"Delete Frames",
		MB_ICONEXCLAMATION | MB_OKCANCEL)
		!= IDOK)
		return;

	for (int j = 0; j < myapp->m_count; j++)
	{
		myapp->m_delete_flag[j] = 0;
	}
	for (;;)
	{
		myapp->m_delete_flag[i] = 1;
		if (count == 0) break;
		int next_i = ((CListCtrl *)GetDlgItem(IDC_LIST3))->GetNextItem(i, LVNI_SELECTED);
		if (next_i == -1) break;
		i = next_i;
	}
	for (;;)
	{
		for (j = 0; j < myapp->m_count; j++)
		{
			if (myapp->m_delete_flag[j]) break;
		}
		if (j == myapp->m_count) break;
		myapp->m_count--;
		for (i = j; i < myapp->m_count; i++)
		{
			strcpy(myapp->m_list[i], myapp->m_list[i + 1]);
			strcpy(myapp->m_title[i], myapp->m_title[i + 1]);
			myapp->m_crop_xoffset[i] = myapp->m_crop_xoffset[i + 1];
			myapp->m_crop_yoffset[i] = myapp->m_crop_yoffset[i + 1];
			myapp->m_crop_width[i] = myapp->m_crop_width[i + 1];
			myapp->m_crop_height[i] = myapp->m_crop_height[i + 1];
			myapp->m_MCUwidth[i] = myapp->m_MCUwidth[i + 1];
			myapp->m_MCUheight[i] = myapp->m_MCUheight[i + 1];
			myapp->m_drop_logo[i] = myapp->m_drop_logo[i + 1];
			myapp->m_drop_legend[i] = myapp->m_drop_legend[i + 1];
			myapp->m_delete_flag[i] = myapp->m_delete_flag[i + 1];
		}
	}
	sprintf(buffer, "%d Frames in List", myapp->m_count);
	SetDlgItemText(IDC_STATICX, buffer);
	((CListCtrl *)GetDlgItem(IDC_LIST3))->DeleteAllItems();
	for (i = 0; i < myapp->m_count; i++)
	{
		sprintf(buffer, "%2d.", i + 1);
		((CListCtrl *)GetDlgItem(IDC_LIST3))->InsertItem(i, buffer);
		((CListCtrl *)GetDlgItem(IDC_LIST3))->SetItemText(i, 1,
			myapp->m_title[i]);
		sprintf(buffer, "%dx%d+%d+%d",
			myapp->m_crop_width[i],
			myapp->m_crop_height[i],
			myapp->m_crop_xoffset[i],
			myapp->m_crop_yoffset[i]);
		((CListCtrl *)GetDlgItem(IDC_LIST3))->SetItemText(i, 2, buffer);
		sprintf(buffer, "%dx%d",
			myapp->m_MCUwidth[i],
			myapp->m_MCUheight[i]);
		((CListCtrl *)GetDlgItem(IDC_LIST3))->SetItemText(i, 3, buffer);
		sprintf(buffer, "%d",
			myapp->m_drop_logo[i]);
		((CListCtrl *)GetDlgItem(IDC_LIST3))->SetItemText(i, 4, buffer);
		sprintf(buffer, "%d",
			myapp->m_drop_legend[i]);
		((CListCtrl *)GetDlgItem(IDC_LIST3))->SetItemText(i, 5, buffer);
	}
}

BEGIN_MESSAGE_MAP(CListDlg, CDialog)
	//{{AFX_MSG_MAP(CListDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CDibLookApp::OnProjectShowList()
{
  CListDlg listDlg;
  listDlg.DoModal();
}

class CSizeDlg : public CDialog
{
public:
	CSizeDlg() : CDialog(CSizeDlg::IDD)
		{
			//{{AFX_DATA_INIT(CSizeDlg)
			//}}AFX_DATA_INIT
		}
// Dialog Data
	//{{AFX_DATA(CSizeDlg)
		enum { IDD = IDD_SIZEBOX };
	//}}AFX_DATA
// Implementation
protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	//{{AFX_MSG(CSizeDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

void CSizeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSizeDlg)
	//}}AFX_DATA_MAP
}

BOOL CSizeDlg::OnInitDialog()
{
  char buffer[128];
  sprintf(buffer, "%d", ((CDibLookApp *)AfxGetApp())->m_cols);
  SetDlgItemText(IDC_EDIT1, buffer);
  sprintf(buffer, "%d", ((CDibLookApp *)AfxGetApp())->m_rows);
  SetDlgItemText(IDC_EDIT2, buffer);
  SetDlgItemText(IDC_EDIT3, ((CDibLookApp *)AfxGetApp())->m_com);
  sprintf(buffer, "%d", ((CDibLookApp *)AfxGetApp())->m_x_spacing);
  SetDlgItemText(IDC_EDIT4, buffer);
  sprintf(buffer, "%d", ((CDibLookApp *)AfxGetApp())->m_y_spacing);
  SetDlgItemText(IDC_EDIT5, buffer);

  if (((CDibLookApp *)AfxGetApp())->m_filecomment[0])
  {
	sprintf(buffer, " File Comment (%s) ", ((CDibLookApp *)AfxGetApp())->m_filecomment);
	SetDlgItemText(IDC_STATICX, buffer);
  }

  CDialog::OnInitDialog();
  return TRUE;
}

void CSizeDlg::OnOK()
{
  CDialog::OnOK();
  char buffer[128];
  GetDlgItemText(IDC_EDIT1, buffer, sizeof(buffer));
  ((CDibLookApp *)AfxGetApp())->m_cols = atoi(buffer);
  GetDlgItemText(IDC_EDIT2, buffer, sizeof(buffer));
  ((CDibLookApp *)AfxGetApp())->m_rows = atoi(buffer);
  GetDlgItemText(IDC_EDIT3, ((CDibLookApp *)AfxGetApp())->m_com,
	  sizeof(((CDibLookApp *)AfxGetApp())->m_com));
  GetDlgItemText(IDC_EDIT4, buffer, sizeof(buffer));
  ((CDibLookApp *)AfxGetApp())->m_x_spacing = atoi(buffer);
  GetDlgItemText(IDC_EDIT5, buffer, sizeof(buffer));
  ((CDibLookApp *)AfxGetApp())->m_y_spacing = atoi(buffer);
}

BEGIN_MESSAGE_MAP(CSizeDlg, CDialog)
	//{{AFX_MSG_MAP(CSizeDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CDibLookApp::OnProjectSaveProjectAs()
{
  CSizeDlg sizeDlg;
  if (sizeDlg.DoModal() != IDOK) return;

  if (m_count == 0) return;

  CString newName = m_list[0];

  if (!DoPromptFileName(newName, AFX_IDS_SAVEFILECOPY,
			OFN_HIDEREADONLY | OFN_PATHMUSTEXIST, FALSE, NULL))
	return;

  BeginWaitCursor();

  int maxwidth = 0, maxheight = 0;

  for (int i = 0; i < m_count; i++)
  {
	if (m_crop_width[i] > maxwidth) maxwidth = m_crop_width[i];
	if (m_crop_height[i] > maxheight) maxheight = m_crop_height[i];
  }

  maxwidth += m_x_spacing; maxheight += m_y_spacing;

  for (i = 0; i < m_count; i++)
  {
	docrop(m_list[i], "tempcrop.jpg",
		   m_crop_xoffset[i], m_crop_yoffset[i],
		   m_crop_width[i], m_crop_height[i],
		   "",
		   m_optimize_coding,
		   m_copyoption);
	if (m_drop_logo[i])
	{
	  m_sampptr[0][0] = '0' + (char)(m_MCUwidth[i] / 8);
	  m_sampptr[0][2] = '0' + (char)(m_MCUheight[i] / 8);
	  dodrop("tempcrop.jpg", m_path[0], "tempcrop.jpg",
			 1, 0, 2, 0,
			 "",
			 m_optimize_coding,
			 m_copyoption);
	}
	if (m_drop_legend[i])
	{
	  m_sampptr[m_drop_legend[i]][0] = '0' + (char)(m_MCUwidth[i] / 8);
	  m_sampptr[m_drop_legend[i]][2] = '0' + (char)(m_MCUheight[i] / 8);
	  dodrop("tempcrop.jpg", m_path[m_drop_legend[i]], "tempcrop.jpg",
			 2, 0, 2, 0,
			 "",
			 m_optimize_coding,
			 m_copyoption);
	}
	if (m_count == 1)
	{
	  docrop("tempcrop.jpg", newName,
			 0, 0,
			 m_cols * maxwidth - m_x_spacing, m_rows * maxheight - m_y_spacing,
			 m_com,
			 m_optimize_coding,
			 m_copyoption);
	}
	else if (i == 0)
	{
	  docrop("tempcrop.jpg", newName,
			 0, 0,
			 m_cols * maxwidth - m_x_spacing, m_rows * maxheight - m_y_spacing,
			 "",
			 m_optimize_coding,
			 m_copyoption);
	}
	else if (i == m_count - 1)
	{
	  dodrop(newName, "tempcrop.jpg", newName,
			 1, (i % m_cols) * maxwidth, 1, (i / m_cols) * maxheight,
			 m_com,
			 m_optimize_coding,
			 m_copyoption);
	}
	else
	{
	  dodrop(newName, "tempcrop.jpg", newName,
			 1, (i % m_cols) * maxwidth, 1, (i / m_cols) * maxheight,
			 "",
			 m_optimize_coding,
			 m_copyoption);
	}
	remove("tempcrop.jpg");
  }

  EndWaitCursor();
}
